class Pro
{
        public: Pro(){;}
                string back(const string& mode, const string& instance); 
}; 

class config
{
	public: string MYDATABASE;
		string MYTOPIC;
		string MYANSWER;
		string MYQUESTION; 
		string FORMAT;
		string hold[6];
		config(const string& instance)
		{
			read(instance);
		}
	private: int read(const string& instance);	
		 string check(const string& option);
};

string Pro::back(const string& mode, const string& instance)
{
       string tmp;
       tmp = "<p><A HREF=\"" + string(URL) + "/";
       if (mode == "dbadmin")
       {
                tmp += string(ADMIN) + "/";
       }
       tmp += "index.cgi?instance=" + instance + "\">BACK</A></P>\n";
        return tmp;
}

string config::check(const string& option)
{
	string tmp, value;
	string::size_type pos;
	for(int i=0;i<6;i++)
	{
		pos = hold[i].find(option);
		if( pos != string::npos )
		{
			tmp.assign(hold[i], (pos + option.length())+1);
			if(tmp != "")
			{
				return tmp;
				tmp = "";
			}
			else
			{
				cout << "<html><body>Error! Undefined option found: " << option << " ! Exit.</body></html>\n";
		 		exit(0);
			}
		}
	}	
	// we came to here? Strange...
	cout << "<html><body>Error! Option not found: " << option << "! Exit.</body></html>\n";
	exit(0);
}

int config::read(const string& instance)
{
	string filename;
	char zeichen;
	string buffer;
	int be_into=0, in=1, out=0, pos=0;
	string start_instance, end_instance;
	start_instance = "<" + instance + ">";
	end_instance = "</" + instance + ">";
	filename = string(PATH) + "/" + string(ADMIN) + "/faq.conf"; 
	ifstream File(filename.c_str());
	if( ! File ) 
	{
		cout << "<html><body>Error! Could not read " << filename << "! Exit</body></html>\n";
		exit(0);
	}
	else
	{
		while(File)
		{
			File.get(zeichen);
			if(zeichen == '\n')
			{
				if(buffer == start_instance || be_into == in)
				{
					if(buffer == end_instance)
					{
						be_into = out;	
					}
					else
					{
						hold[pos] = buffer;
						pos++;
						be_into = in;
					}
				}
				buffer = "";
			}
			else
				buffer += zeichen;	
		}
		if(pos == 0)
		{
			cout << "<html><body>Error! No database definition <b>\"" << instance << "\"</b> found. Exit.</body></html>\n";
			exit(0);
		}
		if(pos < 6)
		{
			// less than 4 items in an instance? strange!
			cout << "<html><body>Error! config seems to be incomplete! Exit</body></html>\n";
			exit(0);
		}
		else
		{
			MYDATABASE = check("DATABASE");
			MYTOPIC = check("TOPIC");
			MYANSWER = check("ANSWER");
			MYQUESTION = check("QUESTION");
			FORMAT = check("FORMAT");
			if(FORMAT != "large" && FORMAT != "topic")
			{
				cout << "<html><body>Error! FORMAT has wrong value: >" << FORMAT << "< ! Exit.</body></html>\n";
				exit(0);
			}
		}	
	}
	return 0;
}
